Index: trunk/src/lib/graphics/importer/static_model.h
===================================================================
--- trunk/src/lib/graphics/importer/static_model.h	(revision 6022)
+++ trunk/src/lib/graphics/importer/static_model.h	(revision 6022)
@@ -0,0 +1,203 @@
+/*!
+ * @file static_model.h
+ * @brief Contains the Model Class that handles Static 3D-Models rendered with glList's
+ */
+
+#ifndef _STATIC_MODEL_H
+#define _STATIC_MODEL_H
+
+#include "model.h"
+
+#include "material.h"
+#include "glincl.h"
+#include "array.h"
+#include <list>
+
+// FORWARD DECLARATION //
+template<class T> class tArray;
+
+
+//! an enumerator fot the different Model Types.
+/**
+   MODEL_DISPLAY_LIST means, that a DisplayList will be built out of the model. This model will be STATIC, meaning it cannot be changed after initialisation.
+   MODEL_VERTEX_ARRAY means, that a VertexArray will be built out of the model. This moel will be DYNAMIX, meaning that one can change the properties from outside of the model.
+ * @todo implement this stuff
+*/
+typedef enum MODEL_TYPE {
+  MODEL_DISPLAY_LIST,
+  MODEL_VERTEX_ARRAY
+};
+
+
+// definition of different modes for setting up Faces
+#define VERTEX 0       //!< If Faces are created WITH Vertex-Coordinate
+#define NORMAL 1       //!< If Faces are created WITH Normals (otherwise autocalculate)
+#define TEXCOORD 2     //!< If Faces are created WITH TextureCoordinate
+
+//! an enumerator for VERTEX_FORMAT
+typedef enum VERTEX_FORMAT {
+  VERTEX_ONLY = VERTEX,
+  VERTEX_NORMAL = NORMAL,
+  VERTEX_TEXCOORD = TEXCOORD,
+  VERTEX_TEXCOORD_NORMAL = NORMAL | TEXCOORD
+};
+
+////////////////////
+/// SUB-ELEMENTS ///
+////////////////////
+//! This is the placeholder of one Vertex beloning to a Face.
+class ModelFaceElement
+{
+ public:
+  ModelFaceElement();
+  ~ModelFaceElement();
+
+  int                 vertexNumber;         //!< The number of the Vertex out of the Array* vertices, this vertex points to.
+  int                 normalNumber;         //!< The number of the Normal out of the Array* normals, this vertex points to.
+  int                 texCoordNumber;       //!< The number of the textureCoordinate out of the Array* vTexture, this vertex points to.
+
+  ModelFaceElement*   next;                 //!< Point to the next FaceElement in this List.
+};
+
+//! This is the placeholder of a Face belonging to a Group of Faces.
+class ModelFace
+{
+ public:
+  ModelFace();
+  ~ModelFace();
+
+  unsigned int        vertexCount;     //!< The Count of vertices this Face has.
+  ModelFaceElement*   firstElem;       //!< Points to the first Vertex (FaceElement) of this Face.
+  Material*           material;        //!< The Material to use.
+
+  ModelFace*          next;            //!< Pointer to the next Face.
+};
+
+//! Group to handle multiple Models per obj-file.
+class ModelGroup
+{
+ public:
+  ModelGroup();
+  ~ModelGroup();
+
+  void cleanup();
+
+  char*        name;           //!< the Name of the Group. this is an identifier, that can be accessed via the draw (char* name) function.
+  GLubyte*     indices;        //!< The indices of the Groups. Needed for vertex-arrays
+  GLuint       listNumber;     //!< The number of the GL-List this Group gets.
+  ModelFace*   firstFace;      //!< The first Face in this group.
+  ModelFace*   currentFace;    //!< The current Face in this Group (the one we are currently working with.)
+  int          faceMode;       //!< The Mode the Face is in: initially -1, 0 for FaceList opened, 1 for Material,  3 for triangle, 4 for Quad, 5+ for Poly @todo ENUM...
+  int          faceCount;      //!< The Number of Faces this Group holds.
+
+  ModelGroup*  next;           //!< Pointer to the next Group.
+};
+
+struct ModelMaterial
+{
+  Material* material;
+  bool external;
+};
+
+/////////////
+/// MODEL ///
+/////////////
+//! Class that handles static 3D-Models.
+/**
+ * it can also read them in and display them.
+ * All the objects are rendered with glLists
+ */
+class StaticModel : public Model
+{
+ public:
+  StaticModel(const char* modelName = NULL, MODEL_TYPE type = MODEL_DISPLAY_LIST);
+  virtual ~StaticModel();
+
+  virtual void draw() const;
+  void draw(int groupNumber) const;
+  void draw(char* groupName) const;
+
+  void rebuild();
+
+  /** @returns Count of the Models (Groups) in this File */
+  inline int getGroupCount() const { return this->groupCount; };
+
+  /** @returns a Pointer to the Vertex-Array, if it was deleted it returns NULL */
+  inline const GLfloat* getVertexArray() const { return this->vertices->getArray(); };
+  /** @returns the VertexCount of this Model */
+  inline unsigned int getVertexCount() const { return this->vertexCount; };
+
+  /** @returns a Pointer to the Normals-Array, if it was deleted it returns NULL */
+  inline const GLfloat* getNormalsArray() const { return this->normals->getArray(); };
+  /** @returns the NormalsCount of this Model */
+  inline unsigned int getNormalsCount() const { return this->normalCount; };
+
+  /** @returns a Pointer to the TexCoord-Array, if it was deleted it returns NULL */
+  inline const GLfloat* getTexCoordArray() const { return this->vTexture->getArray(); };
+  /** @returns the TexCoord-Count of this Model */
+  inline unsigned int getTexCoordCount() const { return this->texCoordCount; };
+
+  /** @returns the Count of Faces of this Model */
+  inline unsigned int getFaceCount() const { return this->faceCount; };
+
+
+  Material* addMaterial(Material* material);
+  Material* addMaterial(const char* materialName);
+
+  bool addGroup(const char* groupString);
+  bool addVertex(const char* vertexString);
+  bool addVertex(float x, float y, float z);
+  bool addFace(const char* faceString);
+  bool addFace(int faceElemCount, VERTEX_FORMAT type, ...);
+  bool addVertexNormal(const char* normalString);
+  bool addVertexNormal(float x, float y, float z);
+  bool addVertexTexture(const char* vTextureString);
+  bool addVertexTexture(float u, float v);
+  bool setMaterial(const char* mtlString);
+  bool setMaterial(Material* mtl);
+  void finalize();
+
+
+ protected:
+  void cubeModel();
+
+  Material* findMaterialByName(const char* materialName);
+
+
+ protected:
+  float            scaleFactor;     //!< The Factor with which the Model should be scaled. @todo maybe one wants to scale the Model after Initialisation
+
+ private:
+  bool buildVertexNormals();
+
+  bool importToDisplayList();
+  bool buildTriangleList();
+  bool addGLElement(ModelFaceElement* elem);
+
+  bool importToVertexArray();
+
+  bool deleteArrays();
+  bool cleanup();
+
+ private:
+  MODEL_TYPE                 type;            //!< A type for the Model
+  bool                       finalized;       //!< Sets the Object to be finalized.
+
+  unsigned int               vertexCount;     //!< A modelwide Counter for vertices.
+  unsigned int               normalCount;     //!< A modelwide Counter for the normals.
+  unsigned int               texCoordCount;   //!< A modelwide Counter for the texCoord.
+  unsigned int               faceCount;       //!< A modelwide Counter for the faces
+  unsigned int               triangleCount;   //!< Number of triangles >= faceCount
+  tArray<GLfloat>*           vertices;        //!< The Array that handles the Vertices.
+  tArray<GLfloat>*           normals;         //!< The Array that handles the Normals.
+  tArray<GLfloat>*           vTexture;        //!< The Array that handles the VertexTextureCoordinates.
+  sTriangleExt*              triangles;       //!< The Array of triangles in the model.h style
+
+  ModelGroup*                firstGroup;      //!< The first of all groups.
+  ModelGroup*                currentGroup;    //!< The currentGroup. this is the one we will work with.
+  int                        groupCount;      //!< The Count of Groups.
+
+  std::list<ModelMaterial*>  materialList;    //!< A list for all the Materials in this Model
+};
+
+#endif
Index: trunk/src/lib/graphics/importer/vertex_array_model.h
===================================================================
--- trunk/src/lib/graphics/importer/vertex_array_model.h	(revision 6012)
+++ trunk/src/lib/graphics/importer/vertex_array_model.h	(revision 6022)
@@ -7,5 +7,5 @@
 #define _VERTEX_ARRAY_MODEL_H
 
-#include "abstract_model.h"
+#include "model.h"
 
 #include "glincl.h"
@@ -22,5 +22,5 @@
 /////////////
 //! Class that handles 3D-Models. it can also read them in and display them.
-class VertexArrayModel : public AbstractModel
+class VertexArrayModel : public Model
 {
  public:
Index: trunk/src/lib/graphics/spatial_separation/quadtree.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree.h	(revision 6012)
+++ trunk/src/lib/graphics/spatial_separation/quadtree.h	(revision 6022)
@@ -12,5 +12,5 @@
 
 #include "base_object.h"
-#include "abstract_model.h"
+#include "model.h"
 
 
Index: trunk/src/lib/graphics/spatial_separation/quadtree_node.cc
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree_node.cc	(revision 6012)
+++ trunk/src/lib/graphics/spatial_separation/quadtree_node.cc	(revision 6022)
@@ -21,5 +21,5 @@
 #include "quadtree.h"
 #include "material.h"
-#include "abstract_model.h"
+#include "model.h"
 #include "debug.h"
 
@@ -346,5 +346,5 @@
 /**
  *  gets the maximal dimension of a model
- * @return the dimension of the AbstractModel as a Rectangle
+ * @return the dimension of the Model as a Rectangle
 
    The rectangle is x-z axis aligned. ATTENTION: if there are any vertices in the model, that exceed the
Index: trunk/src/lib/graphics/spatial_separation/quadtree_node.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/quadtree_node.h	(revision 6012)
+++ trunk/src/lib/graphics/spatial_separation/quadtree_node.h	(revision 6022)
@@ -17,5 +17,5 @@
 #include "base_object.h"
 
-#include "abstract_model.h"
+#include "model.h"
 
 // FORWARD DECLARATION
Index: trunk/src/lib/graphics/spatial_separation/spatial_separation.cc
===================================================================
--- trunk/src/lib/graphics/spatial_separation/spatial_separation.cc	(revision 6012)
+++ trunk/src/lib/graphics/spatial_separation/spatial_separation.cc	(revision 6022)
@@ -18,5 +18,5 @@
 #include "spatial_separation.h"
 
-#include "abstract_model.h"
+#include "model.h"
 #include "quadtree.h"
 #include "debug.h"
@@ -34,5 +34,5 @@
 
  */
-SpatialSeparation::SpatialSeparation (AbstractModel* model, float overlapSize)
+SpatialSeparation::SpatialSeparation (Model* model, float overlapSize)
 {
   PRINT(3)("+---------Debug Information SpatialSeparation----------\n");
@@ -52,5 +52,5 @@
    The boxes are overlaping because this makes collision detection a lot simpler
  */
-SpatialSeparation::SpatialSeparation (AbstractModel* model, AbstractModel* playerModel)
+SpatialSeparation::SpatialSeparation (Model* model, Model* playerModel)
 {
   this->setClassID(CL_SPATIAL_SEPARATION, "SpatialSeparation");
@@ -75,5 +75,5 @@
  * @return the new quadtree
  */
-Quadtree* SpatialSeparation::createQuadtree(AbstractModel* model, float minLength)
+Quadtree* SpatialSeparation::createQuadtree(Model* model, float minLength)
 {
   this->minLength = minLength;
@@ -88,5 +88,5 @@
  * @return the new quadtree
  */
-Quadtree* SpatialSeparation::createQuadtree(AbstractModel* model, int treeDepth)
+Quadtree* SpatialSeparation::createQuadtree(Model* model, int treeDepth)
 {
   this->treeDepth = treeDepth;
@@ -100,5 +100,5 @@
  * @return the new quadtree
  */
-Quadtree* SpatialSeparation::createQuadtree(AbstractModel* model)
+Quadtree* SpatialSeparation::createQuadtree(Model* model)
 {
   this->quadtree = new Quadtree(model->getModelInfo(), 4);
Index: trunk/src/lib/graphics/spatial_separation/spatial_separation.h
===================================================================
--- trunk/src/lib/graphics/spatial_separation/spatial_separation.h	(revision 6012)
+++ trunk/src/lib/graphics/spatial_separation/spatial_separation.h	(revision 6022)
@@ -9,5 +9,5 @@
 
 
-class AbstractModel;
+class Model;
 class Quadtree;
 
@@ -21,6 +21,6 @@
 
   public:
-    SpatialSeparation(AbstractModel* model, float overlapSize);
-    SpatialSeparation(AbstractModel* model, AbstractModel* playerModel);
+    SpatialSeparation(Model* model, float overlapSize);
+    SpatialSeparation(Model* model, Model* playerModel);
     virtual ~SpatialSeparation();
 
@@ -28,7 +28,7 @@
     void setMinLength(int minLength) { this->minLength = minLength; }
 
-    Quadtree* createQuadtree(AbstractModel* model, float minLength);
-    Quadtree* createQuadtree(AbstractModel* model, int treeDepth);
-    Quadtree* createQuadtree(AbstractModel* model);
+    Quadtree* createQuadtree(Model* model, float minLength);
+    Quadtree* createQuadtree(Model* model, int treeDepth);
+    Quadtree* createQuadtree(Model* model);
 
     inline Quadtree* getQuadtree() { return this->quadtree; }
@@ -41,8 +41,8 @@
 
   private:
-    AbstractModel*             model;        //!< the reference to the model that has to be handled
+    Model*             model;        //!< the reference to the model that has to be handled
     Quadtree*                  quadtree;     //!< the reference to the created quadtree
 
-    AbstractModel*             playerModel;  //!< referece to the player model, if needed for overlap calculations
+    Model*             playerModel;  //!< referece to the player model, if needed for overlap calculations
     float                      overlapSize;  //!< the size of overlaping
 
Index: trunk/src/world_entities/skybox.cc
===================================================================
--- trunk/src/world_entities/skybox.cc	(revision 6012)
+++ trunk/src/world_entities/skybox.cc	(revision 6022)
@@ -20,6 +20,6 @@
 #include "load_param.h"
 #include "factory.h"
-#include "model.h"
-
+#include "static_model.h"
+#include "material.h"
 
 using namespace std;
@@ -170,5 +170,5 @@
 void SkyBox::rebuild()
 {
-  Model* model = new Model();
+  StaticModel* model = new StaticModel();
 
   model->addVertex (-0.5*size, -0.5*size, 0.5*size);
Index: trunk/src/world_entities/terrain.cc
===================================================================
--- trunk/src/world_entities/terrain.cc	(revision 6012)
+++ trunk/src/world_entities/terrain.cc	(revision 6022)
@@ -40,5 +40,5 @@
 
 //  if (this->model != NULL)
-    //this->ssp = new SpatialSeparation((AbstractModel*)this->model, 10.0f);
+    //this->ssp = new SpatialSeparation((Model*)this->model, 10.0f);
 }
 
Index: trunk/src/world_entities/weapons/test_gun.cc
===================================================================
--- trunk/src/world_entities/weapons/test_gun.cc	(revision 6012)
+++ trunk/src/world_entities/weapons/test_gun.cc	(revision 6022)
@@ -24,5 +24,5 @@
 
 #include "world_entity.h"
-#include "model.h"
+#include "static_model.h"
 #include "test_bullet.h"
 #include "weapon_manager.h"
@@ -219,5 +219,5 @@
   if( this->leftRight == W_RIGHT)
     glScalef(1.0, 1.0, -1.0);
-  this->getModel()->draw(1);
+  static_cast<StaticModel*>(this->getModel())->draw(1);
   glPopMatrix();
 
@@ -230,5 +230,5 @@
   tmpRot = this->objectComponent1->getAbsDir().getSpacialAxis();
   glRotatef (this->objectComponent1->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
-  this->getModel()->draw(0);
+  static_cast<StaticModel*>(this->getModel())->draw(0);
   glPopMatrix();
 }
